> For the complete documentation index, see [llms.txt](https://docs.parallels.com/landing/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/site-settings/mfa/mfa-default-settings/criteria/security-principals.md).

# Security Principals

## List

> Retrieve Criteria Security Principal List of a Site Defaults object.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/MFADefaultSettings/Criteria/SecurityPrincipals":{"get":{"tags":["2-Site settings/Multi-factor Authentication/1-Default settings/Criteria//Security Principal"],"summary":"List","description":"Retrieve Criteria Security Principal List of a Site Defaults object.","operationId":"71a54dc0-76d1-4d51-9f10-8499edd33438","parameters":[{"name":"siteId","in":"query","description":"The SiteId of a Site Defaults object for which to retrieve the Criteria settings (optional).","schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"Success","content":{"application/json; api-version=1.0":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/SecurityPrincipalCriteriaEntry"}}}}},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"SecurityPrincipalCriteriaEntry":{"type":"object","properties":{"account":{"type":"string","description":"<para type=\"description\">The name of the user/group account the filter is added to.</para>","nullable":true},"type":{"$ref":"#/components/schemas/UserType"},"sid":{"type":"string","description":"<para type=\"description\">The SID of the user/group account the filter is added to.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Security Principal Criteria Entry</para>\r\n<para type=\"description\"></para>"},"UserType":{"enum":[["1 = User","2 = Group","3 = ForeignSecurityPrincipal","4 = Computer"]],"type":"string","description":"<para type=\"synopsis\">User Type</para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```

## Add

> Add a user, group or machine to the Security Principal List of the Criteria settings.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/MFADefaultSettings/Criteria/SecurityPrincipals":{"post":{"tags":["2-Site settings/Multi-factor Authentication/1-Default settings/Criteria//Security Principal"],"summary":"Add","description":"Add a user, group or machine to the Security Principal List of the Criteria settings.","operationId":"a3d715cd-c427-45b7-a4e6-97321bbc632b","parameters":[{"name":"siteId","in":"query","description":"The Site ID of an object for which to modify the Criteria settings (optional).","schema":{"type":"integer","format":"int32"}}],"requestBody":{"description":"SecurityPrincipal configuration.","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/AddCriteriaSecurityPrincipal"}}}},"responses":{"201":{"description":"Created"},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"AddCriteriaSecurityPrincipal":{"type":"object","properties":{"account":{"maxLength":255,"minLength":1,"type":"string","description":"<para type=\"description\">The name of the account to add to the Criteria.</para>","nullable":true},"sid":{"maxLength":255,"minLength":1,"type":"string","description":"<para type=\"description\">The SID of the account to add to the Criteria.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Add a user, group or machine account to the Criteria security principal list</para>\r\n<para type=\"description\"></para>"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```

## Remove

> Remove a user, group or machine from the Security Principal List of the Criteria settings.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/MFADefaultSettings/Criteria/SecurityPrincipals":{"delete":{"tags":["2-Site settings/Multi-factor Authentication/1-Default settings/Criteria//Security Principal"],"summary":"Remove","description":"Remove a user, group or machine from the Security Principal List of the Criteria settings.","operationId":"93202376-8194-49eb-98df-1e0c42e1f4da","parameters":[{"name":"siteId","in":"query","description":"The Site ID of an object for which to modify the Criteria settings (optional).","schema":{"type":"integer","format":"int32"}}],"requestBody":{"description":"SecurityPrincipal configuration.","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/RemoveCriteriaSecurityPrincipal"}}}},"responses":{"204":{"description":"No Content"},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"RemoveCriteriaSecurityPrincipal":{"type":"object","properties":{"account":{"maxLength":255,"minLength":1,"type":"string","description":"<para type=\"description\">The name of the account to remove from the Criteria.</para>","nullable":true},"sid":{"maxLength":255,"minLength":1,"type":"string","description":"<para type=\"description\">The SID of the account to remove from the Criteria.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Remove a user, group or machine from the Criteria security principal list</para>\r\n<para type=\"description\"></para>"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/site-settings/mfa/mfa-default-settings/criteria/security-principals.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
